<template>
  <div>
    <RouterView v-if="moduleIsReady" />
    <b-row v-else align-h="center" class="my-4">
      <b-spinner variant="primary" />
    </b-row>
  </div>
</template>

<script lang="ts">
// import the store for current module
import useUserStore from "../user/store";
import useProjectStore from "./store";

export default defineComponent({
  async beforeRouteUpdate(to, from, next) {
    await this.apiFetch();
    next();
  },

  setup() {
    const projectStore = useProjectStore();
    const userStore = useUserStore();

    return { projectStore, userStore };
  },

  computed: {
    areTosAccepted(): boolean {
      // This additional check is necessary, as this page acts as "home",
      // meanwhile is dependent on ToS acceptance
      return this.userStore.user?.areToSAccepted ?? false;
    },
    moduleIsReady(): boolean {
      return (
        this.projectStore.topLevelProjects !== null &&
        this.projectStore.roles !== null
      );
    },
  },

  watch: {
    areTosAccepted() {
      this.initialize();
    },
  },

  created() {
    this.initialize();
  },

  methods: {
    async initialize() {
      if (this.areTosAccepted) {
        await this.apiFetch();
      }
    },

    async apiFetch() {
      // Clear the current slug
      this.projectStore.currentSlug = null;

      const promises: Promise<void>[] = [];
      // Load All Projects if not present
      if (this.projectStore.allProjects === null) {
        promises.push(this.projectStore.retrieveAllProjects());
      }
      if (this.projectStore.roles === null) {
        promises.push(this.projectStore.retrieveRoles());
      }
      // Load Top Level Projects if not present
      if (this.projectStore.topLevelProjects === null) {
        promises.push(this.projectStore.retrieveTopLevelProjects());
      }
      await Promise.all(promises);
    },
  },
});
</script>
